class
	C2EIFFEL

inherit
	ARGUMENTS
	EXECUTION_ENVIRONMENT
		rename
			command_line as command_line_ex_env
		end

create
	make

feature {NONE}

	make
		local
			l_project_settings: PROJECT_SETTINGS
			l_open_gui: BOOLEAN
			l_i: INTEGER_32
			l_wrong_args: BOOLEAN
		do
			create l_project_settings
			if
				argument_count = 3 and then
				argument_array[2].is_equal ("-callback")
			then
				-- EiffelStudio wizard mode
				l_project_settings.wizard_file := argument_array[3]
				(create {C2EIFFEL_GUI}).launch_gui (l_project_settings)
			else
				l_open_gui := True
				from
					l_i := 1
				until
					l_wrong_args or l_i > argument_count
				loop
					if argument_array[l_i].is_equal ("-gui") then
						l_open_gui := True
					elseif argument_array[l_i].is_equal ("-cmd") then
						l_open_gui := False
					elseif argument_array[l_i].is_equal ("-cil-file") and l_i + 1 <= argument_count then
						if attached {RAW_FILE} (create {RAW_FILE}.make (argument_array[l_i + 1])) as tmp and then tmp.exists then
							l_project_settings.cil_file := tmp
							l_i := l_i + 1
						else
							Io.error.put_string ("Invalid arguments: CIL file %"" + argument_array[l_i + 1] + "%" doesn't exist.%N")
							l_wrong_args := True
						end
					elseif argument_array[l_i].is_equal ("-out-dir") and l_i + 1 <= argument_count then
						if attached {DIRECTORY} (create {DIRECTORY}.make (argument_array[l_i + 1])) as tmp and then tmp.exists then
							l_project_settings.output_dir := tmp
							l_i := l_i + 1
						else
							Io.error.put_string ("Invalid arguments: Output directory %"" + argument_array[l_i + 1] + "%" doesn't exist.%N")
							l_wrong_args := True
						end
					elseif argument_array[l_i].is_equal ("-L") and l_i + 1 <= argument_count then
						l_project_settings.libraries.extend (argument_array[l_i + 1])
						l_i := l_i + 1
					elseif argument_array[l_i].is_equal ("-I") and l_i + 1 <= argument_count then
						l_project_settings.include_dirs.extend (argument_array[l_i + 1])
						l_i := l_i + 1
					elseif argument_array[l_i].is_equal ("-enable-oo-structs")  then l_project_settings.disable_oo_structs := False
					elseif argument_array[l_i].is_equal ("-disable-oo-structs") then l_project_settings.disable_oo_structs := True
					elseif argument_array[l_i].is_equal ("-enable-oo-reengineering")  then l_project_settings.disable_oo_reengineering := False
					elseif argument_array[l_i].is_equal ("-disable-oo-reengineering") then l_project_settings.disable_oo_reengineering := True
					elseif argument_array[l_i].is_equal ("-enable-multithreading")  then l_project_settings.is_multithreaded := True
					elseif argument_array[l_i].is_equal ("-disable-multithreading") then l_project_settings.is_multithreaded := False
					elseif argument_array[l_i].is_equal ("-enable-bounds-checking")  then l_project_settings.disable_bounds_checking := False
					elseif argument_array[l_i].is_equal ("-disable-bounds-checking") then l_project_settings.disable_bounds_checking := True
					else
						Io.error.put_string ("Invalid arguments: Option %"" + argument_array[l_i] + "%" is not known.%N")
						l_wrong_args := True
					end
					l_i := l_i + 1
				end
				if (not l_open_gui) and (l_project_settings.cil_file = Void or l_project_settings.output_dir = Void) then
					Io.error.put_string ("Invalid arguments: CIL file and output directory need to be provided.%N")
					l_wrong_args := True
				end
				if not l_wrong_args then
					if l_open_gui then
						(create {C2EIFFEL_GUI}).launch_gui (l_project_settings)
					else
						launch_cmd (l_project_settings)
					end
				end
			end
		end

	launch_cmd (a_project_settings: PROJECT_SETTINGS)
		require
			a_project_settings /= Void
		local
			transformer: CODE_TRANSFORMER
			ok: BOOLEAN
		do
			(create {VIEW_INTERFACE}).impl_log.log := agent (msg: ANY)
				do
					Io.put_string (msg.out)
					Io.put_new_line
				end

			create transformer.make (a_project_settings)
			ok := transformer.go (transformer.steps.count)
			if ok then
				Io.put_string ("Done.%N")
			else
				Io.put_string ("Failed.%N")
				(create {EXCEPTIONS}).die (-1)
			end
		end

end
