class
	AST_TRANSLATION_UNIT

inherit
	AST_NODE

create
	make,
	make_copy

feature {NONE}

	make
		do
			declarations := create {TWO_WAY_LIST [AST_DECLARATION]}.make
		end

feature {ANY}

	declarations: LIST [AST_DECLARATION]

	source_file_name: STRING_8 assign set_source_file_name

	set_source_file_name (a_source_file_name: STRING_8)
		require
			a_source_file_name /= Void and then not a_source_file_name.is_empty
		do
			source_file_name := a_source_file_name
		end

feature {ANY}

	get_declaration (a_identifier: STRING_8): AST_DECLARATION
		do
			across
				declarations as c
			until
				Result /= Void
			loop
				if c.item.identifier.is_equal (a_identifier) then
					Result := c.item
				end
			end
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_translation_unit (Current)
			if visit_children then
				visit_list (declarations, v)
			end
			v.end_visit_translation_unit (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			declarations := create {TWO_WAY_LIST [AST_DECLARATION]}.make
			across other.declarations as c loop
				declarations.extend (c.item.ast_twin)
				declarations.last.parent := Current
			end
			source_file_name := other.source_file_name.twin
		end

invariant
	declarations /= Void

end
