class
	AST_GCC_ATTRIBUTE

inherit
	AST_NODE
	ANTLR_TRANSFORMATION_UTILITIES

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; a_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_gcc_attribute
		do
			parent := a_parent

			from
				node.children.start
				identifier := node.children.item.token_text
				node.children.forth
				expressions := create {TWO_WAY_LIST [AST_EXPRESSION]}.make
			until
				node.children.after
			loop
				expressions.extend (process_expression (node.children.item, Current))
				node.children.forth
			end
		end

feature {ANY}

	identifier: STRING_8

	expressions: LIST [AST_EXPRESSION]

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_attribute (Current)
			if visit_children then
				visit_list (expressions, v)
			end
			v.end_visit_attribute (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (a_other: like Current)
		do
			identifier := a_other.identifier
			expressions := create {TWO_WAY_LIST [AST_EXPRESSION]}.make
			across a_other.expressions as c loop
				expressions.extend (c.item.ast_twin)
				expressions.last.parent := Current
			end
		end

invariant
	identifier /= Void and then not identifier.is_empty
	expressions /= Void

end
