class
	AST_ASM_OPERAND

inherit
	AST_NODE

create
	make,
	make_copy

feature {NONE}

	make (a_constraint: STRING; a_expression: AST_EXPRESSION)
		require
			a_constraint /= Void and then not a_constraint.is_empty
			a_expression /= Void and then a_expression.parent = Void
		do
			constraint := a_constraint
			expression := a_expression
			expression.parent := Current
			orig_c_expression := expression.ast_twin
			orig_c_expression.is_orig_c_expression := True
		end

feature {ANY}

	constraint: STRING

	expression: AST_EXPRESSION

	orig_c_expression: AST_EXPRESSION

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_asm_operand (Current)
			if visit_children then
				visit_node (expression, v)
			end
			v.end_visit_asm_operand (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			constraint := other.constraint.twin
			expression := other.expression.ast_twin
			expression.parent := Current
			orig_c_expression := other.orig_c_expression -- won't be changed
		end

invariant
	constraint /= Void and then not constraint.is_empty
	expression /= Void
	orig_c_expression /= Void

end
