class
	AST_SWITCH_CASE

inherit
	AST_STATEMENT

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = C_kw_case
		do
			parent := init_parent
			condition := process_expression (node.children.first, Current)
		end

feature {ANY}

	condition: AST_EXPRESSION

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_switch_case (Current)
			if visit_children then
				visit_node (condition, v)
			end
			v.end_visit_switch_case (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			condition := other.condition.ast_twin
			condition.parent := Current
		end

invariant
	condition /= Void

end
