class
	CALL_GRAPH_NODE

inherit
	HASHABLE

create
	make

feature {NONE}

	make (a_ast_feature: AST_EIFFEL_FEATURE)
		do
			ast_feature := a_ast_feature
			create out_calls.make (16)
			create in_calls.make (16)
		end

feature {ANY}

	ast_feature: AST_EIFFEL_FEATURE

	out_calls, in_calls: HASH_SET [CALL_GRAPH_NODE]

feature {ANY}

	add_out_call (a_to: CALL_GRAPH_NODE)
		require
			a_to /= Void and a_to /= Current
		do
			out_calls.extend (a_to)
			a_to.in_calls.extend (Current)
		end

	remove_out_calls
		do
			across out_calls as c loop
				c.item.in_calls.remove (Current)
			end
			out_calls.wipe_out
		end

feature {ANY}

	hash_code: INTEGER_32
		do
			Result := ast_feature.hash_code
		end

invariant
	ast_feature /= Void
	out_calls /= Void
	in_calls /= Void

end
