class
	EXIT_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_function_call
		end

feature {ANY} -- TRANSFORMATION_STEP

	process (transformer: CODE_TRANSFORMER; error_log: EV_TEXT): BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description : STRING
		do
			Result := "Transforming %"exit%" to the Eiffel equivalent"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_function_call (node: AST_FUNCTION_CALL)
		do
			if node.identifier.is_equal ("exit") then
				node.identifier.make_from_string ("{EXCEPTIONS}.die")
			end
		end

end
