class
	AST_TREE_PRINTER

inherit
	AST_DEFAULT_VISITOR
		redefine
			pre_visit,
			post_visit
		end

create
	make

feature {NONE}

	tree: EV_TREE
	item_stack: STACK [EV_TREE_ITEM]

	make (a_tree: EV_TREE)
		do
			tree := a_tree
			item_stack := create {LINKED_STACK [EV_TREE_ITEM]}.make
		end

feature {ANY}

	pre_visit (a_node: AST_NODE)
		local
			l_label: STRING_8
			l_item: EV_TREE_ITEM
		do
			l_label := a_node.generator
			if attached {AST_DECLARATION} a_node as d then
				l_label.append (": " + d.identifier)
			end
			create l_item.make_with_text (l_label)
			l_item.set_data (a_node)
			if item_stack.is_empty then
				tree.extend (l_item)
			else
				item_stack.item.extend (l_item)
			end
			item_stack.extend (l_item)
		end

	post_visit (node: AST_NODE)
		do
			item_stack.remove
		end

end
